<?php

/**
 * @package themify
 * @since 1.1.2
 * @author Elio Rivero
 * 
 * ----------------------------------------------------------------------
 * 					DO NOT EDIT THIS FILE
 * ----------------------------------------------------------------------
 * 				Themify Shortcodes
 *  			http://themify.me
 *  			Copyright (C) Themify
 *
 ***************************************************************************/

/* 	Database Functions
/***************************************************************************/
	
	/**
	 * Save Data
	 * @param Array $data
	 * @return String
	 * @since 1.0.0
	 * @package themify
	 */
	function themify_set_data($data){
		$theme = wp_get_theme();
		foreach($data as $name => $value){
			if('save' == $name || 'page' == $name){
				unset($data[$name]);	
			}
		}
		$option_value = base64_encode(serialize($data)); 
		update_option( $theme->display('Name') . '_themify_data', $option_value);
		return $option_value;
	}
		
	/**
	 * Get Data
	 * @return String
	 * @since 1.0.0
	 * @package themify
	 */
	function themify_get_data(){
		$theme = wp_get_theme();
		$data = unserialize(base64_decode( get_option( $theme->display('Name') . '_themify_data' ) ));
		if(is_array($data) && count($data) >= 1){
			foreach($data as $name => $value){
				$data[$name] = stripslashes($value);	
			}
		}
		return $data;
	}
	
?>